/* Estabelece conexo com o banco */

CONNECT 'C:\Livros\Firebird\Projetos\Activity.gdb' 
  USER 'SYSDBA' PASSWORD 'masterkey';

/* Desativa commit automtico */

SET AUTODDL OFF;

/* Define integridade referencial */

ALTER TABLE Departamento
  ADD CONSTRAINT FK_DEPARTAMENTO_DEPARTAMENTO 
  FOREIGN KEY (Nu_Depto_Superior) 
  REFERENCES Departamento (Nu_Departamento)
  ON DELETE SET NULL;

ALTER TABLE Recurso 
  ADD CONSTRAINT FK_RECURSO_DEPARTAMENTO 
  FOREIGN KEY (Nu_Departamento) 
  REFERENCES Departamento (Nu_Departamento)
  ON DELETE SET NULL;

ALTER TABLE Recurso 
  ADD CONSTRAINT FK_RECURSO_CARGO
  FOREIGN KEY (Nu_Cargo) 
  REFERENCES Cargo (Nu_Cargo)
  ON DELETE SET NULL;

ALTER TABLE Projeto 
  ADD CONSTRAINT FK_PROJETO_DEPARTAMENTO 
  FOREIGN KEY (Nu_Departamento) 
  REFERENCES Departamento (Nu_Departamento)
  ON DELETE CASCADE;

ALTER TABLE Projeto 
  ADD CONSTRAINT FK_PROJETO_RECURSO 
  FOREIGN KEY (Nu_Recurso) 
  REFERENCES Recurso (Nu_Recurso)
  ON DELETE SET NULL;

ALTER TABLE Atividade 
  ADD CONSTRAINT FK_ATIVIDADE_PROJETO 
  FOREIGN KEY (Nu_Departamento, Nu_Projeto) 
  REFERENCES Projeto (Nu_Departamento, Nu_Projeto)
  ON DELETE CASCADE;

ALTER TABLE Tarefa 
  ADD CONSTRAINT FK_TAREFA_ATIVIDADE 
  FOREIGN KEY (Nu_Departamento, Nu_Projeto, Nu_Atividade) 
  REFERENCES Atividade (Nu_Departamento, Nu_Projeto, Nu_Atividade)
  ON DELETE CASCADE;

ALTER TABLE Processo 
  ADD CONSTRAINT FK_PROCESSO_TAREFA 
  FOREIGN KEY (Nu_Departamento, Nu_Projeto, Nu_Atividade, Nu_Tarefa) 
  REFERENCES Tarefa (Nu_Departamento, Nu_Projeto, Nu_Atividade, Nu_Tarefa)
  ON DELETE CASCADE;

ALTER TABLE Processo 
  ADD CONSTRAINT FK_PROCESSO_RECURSO 
  FOREIGN KEY (Nu_Recurso) 
  REFERENCES Recurso (Nu_Recurso)
  ON DELETE CASCADE;

ALTER TABLE Dossie 
  ADD CONSTRAINT FK_DOSSIE_PROCESSO 
  FOREIGN KEY (Nu_Departamento, Nu_Projeto, Nu_Atividade, Nu_Tarefa, Nu_Recurso) 
  REFERENCES Processo (Nu_Departamento, Nu_Projeto, Nu_Atividade, Nu_Tarefa, Nu_Recurso);

/* Salva as alteraes */

COMMIT WORK;

/* Ativa commit automtico */

SET AUTODDL ON;
