/* Estabelece conexo com o banco */

CONNECT 'C:\Livros\Firebird\Projetos\Activity.gdb' 
  USER 'SYSDBA' PASSWORD 'masterkey';

/* Desativa commit automtico */

SET AUTODDL OFF;

/* Modifica o terminador de comandos */

SET TERM ^;

/* Define procedimentos armazenados */

CREATE PROCEDURE projeto_sequencial
(
  Nu_Departamento INTEGER
)
RETURNS
(
  Nu_Projeto INTEGER
)
AS
  DECLARE VARIABLE sequencial INTEGER;
BEGIN
  Nu_Projeto = 1;

  SELECT (MAX(Nu_Projeto)+1)
  FROM   Projeto   
  WHERE  Nu_Departamento = :Nu_Departamento
  INTO   :sequencial;

  IF (sequencial IS NOT NULL) THEN
    Nu_Projeto = sequencial;
END
^

CREATE PROCEDURE atividade_sequencial
(
  Nu_Departamento INTEGER,
  Nu_Projeto INTEGER
)
RETURNS
(
  Nu_Atividade INTEGER
)
AS
  DECLARE VARIABLE sequencial INTEGER;
BEGIN
  Nu_Atividade = 1;

  SELECT (MAX(Nu_Atividade)+1)
  FROM   Atividade
  WHERE  Nu_Departamento = :Nu_Departamento
  AND    Nu_Projeto = :Nu_Projeto
  INTO   :sequencial;

  IF (sequencial IS NOT NULL) THEN
    Nu_Atividade = sequencial;
END
^

CREATE PROCEDURE tarefa_sequencial
(
  Nu_Departamento INTEGER,
  Nu_Projeto INTEGER,
  Nu_Atividade INTEGER
)
RETURNS
(
  Nu_Tarefa INTEGER
)
AS
  DECLARE VARIABLE sequencial INTEGER;
BEGIN
  Nu_Tarefa = 1;

  SELECT (MAX(Nu_Tarefa)+1)
  FROM   Tarefa
  WHERE  Nu_Departamento = :Nu_Departamento
  AND    Nu_Projeto = :Nu_Projeto
  AND    Nu_Atividade = :Nu_Atividade
  INTO   :sequencial;

  IF (sequencial IS NOT NULL) THEN
    Nu_Tarefa = sequencial;
END
^

CREATE PROCEDURE projeta_salarios
(
  Percentual_Executivo NUMERIC(5,2),
  Percentual_Generico  NUMERIC(5,2)
)
RETURNS
(
  No_Recurso CHAR(50),
  No_Cargo   CHAR(30),
  Novo_Valor NUMERIC(15,2)
)
AS
  DECLARE VARIABLE Nu_Cargo INTEGER;
BEGIN
  FOR SELECT   DISTINCT
               r.No_Recurso, 
               c.Nu_Cargo,
               c.No_Cargo,
               c.Valor
      FROM     Recurso r, Cargo c
      WHERE    r.Nu_Cargo = c.Nu_Cargo
      ORDER BY r.No_Recurso 
      INTO     :No_Recurso,
               :Nu_Cargo,
               :No_Cargo,
               :Novo_Valor 
  DO
  BEGIN
    IF (Nu_Cargo = 1 OR Nu_Cargo = 3) THEN
      Novo_Valor = Novo_Valor * ( 1 + Percentual_Executivo/100 );
    ELSE
      Novo_Valor = Novo_Valor * ( 1 + Percentual_Generico/100 );
    SUSPEND;
  END
END
^

/* Restaura o terminador de comandos */

SET TERM ;^

/* Salva as alteraes */

COMMIT WORK;

/* Define permisses sobre procedimentos */

GRANT EXECUTE ON PROCEDURE projeto_sequencial   TO PUBLIC;
GRANT EXECUTE ON PROCEDURE atividade_sequencial TO PUBLIC;
GRANT EXECUTE ON PROCEDURE tarefa_sequencial    TO PUBLIC;
GRANT EXECUTE ON PROCEDURE projeta_salarios     TO PUBLIC;

/* Salva as alteraes */

COMMIT WORK;

/* Ativa commit automtico */

SET AUTODDL ON;
