unit uDossie;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, DBCtrls, Grids, DBGrids, StdCtrls, Buttons;

type
  TfDossie = class(TForm)
    DBGrid: TDBGrid;
    DBNavigator: TDBNavigator;
    Label1: TLabel;
    Label2: TLabel;
    btIncluir: TButton;
    btAlterar: TButton;
    btExcluir: TButton;
    btSai: TBitBtn;
    procedure btIncluirClick(Sender: TObject);
    procedure btAlterarClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure btSaiClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  fDossie: TfDossie;

implementation

uses udmActivity, u2Dossie;

{$R *.dfm}

procedure TfDossie.FormShow(Sender: TObject);
begin
  DBGrid.DataSource := fdmActivity.dsDossie;
  DBNavigator.DataSource := fdmActivity.dsDossie;
  fdmActivity.qryDossie.Open;
end;

procedure TfDossie.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
{ Libera o formulrio }
  Action := caFree;
  fDossie := nil;
end;

procedure TfDossie.btIncluirClick(Sender: TObject);
begin
  if f2Dossie = nil then
    f2Dossie := Tf2Dossie.Create(Application);

  with f2Dossie, fdmActivity.qryDossie do
  begin
    lbOperacao.Caption := 'Incluir Dossi';

    edNu_Departamento.Color    := clWindow;
    edNu_Departamento.ReadOnly := False;
    edNu_Departamento.TabStop  := True;
    edNu_Projeto.Color         := clWindow;
    edNu_Projeto.ReadOnly      := False;
    edNu_Projeto.TabStop       := True;
    edNu_Atividade.Color       := clWindow;
    edNu_Atividade.ReadOnly    := False;
    edNu_Atividade.TabStop     := True;
    edNu_Tarefa.Color          := clWindow;
    edNu_Tarefa.ReadOnly       := False;
    edNu_Tarefa.TabStop        := True;
    edNu_Recurso.Color         := clWindow;
    edNu_Recurso.ReadOnly      := False;
    edNu_Recurso.TabStop       := True;
    edDt_Referencia.Color      := clWindow;
    edDt_Referencia.ReadOnly   := False;
    edDt_Referencia.TabStop    := True;

    edNu_Departamento.Text   := '';
    edNu_Projeto.Text        := '';
    edNu_Atividade.Text      := '';
    edNu_Tarefa.Text         := '';
    edNu_Recurso.Text        := '';
    edDt_Referencia.Text     := '';
    edHoras_Trabalhadas.Text := '';
    edAndamento.Clear;
    edNo_Departamento.Text   := '';
    edNo_Projeto.Text        := '';
    edNo_Atividade.Text      := '';
    edNo_Tarefa.Text         := '';
    edNo_Recurso.Text        := '';

    ShowModal;
    Open;
  end;
end;

procedure TfDossie.btAlterarClick(Sender: TObject);
begin
  if f2Dossie = nil then
    f2Dossie := Tf2Dossie.Create(Application);

  with f2Dossie, fdmActivity.qryDossie do
  begin
    if (Sender = btAlterar) then
      lbOperacao.Caption := 'Alterar Dossi'
    else
    if (Sender = btExcluir) then
      lbOperacao.Caption := 'Excluir Dossi';

    edNu_Departamento.Color    := clSilver;
    edNu_Departamento.ReadOnly := True;
    edNu_Departamento.TabStop  := False;
    edNu_Projeto.Color         := clSilver;
    edNu_Projeto.ReadOnly      := True;
    edNu_Projeto.TabStop       := False;
    edNu_Atividade.Color       := clSilver;
    edNu_Atividade.ReadOnly    := True;
    edNu_Atividade.TabStop     := False;
    edNu_Tarefa.Color          := clSilver;
    edNu_Tarefa.ReadOnly       := True;
    edNu_Tarefa.TabStop        := False;
    edNu_Recurso.Color         := clSilver;
    edNu_Recurso.ReadOnly      := True;
    edNu_Recurso.TabStop       := False;
    edDt_Referencia.Color      := clSilver;
    edDt_Referencia.ReadOnly   := True;
    edDt_Referencia.TabStop    := False;

    edNu_Departamento.Text   := FieldByName('Nu_Departamento').AsString;
    edNu_Projeto.Text        := FieldByName('Nu_Projeto').AsString;
    edNu_Atividade.Text      := FieldByName('Nu_Atividade').AsString;
    edNu_Tarefa.Text         := FieldByName('Nu_Tarefa').AsString;
    edNu_Recurso.Text        := FieldByName('Nu_Recurso').AsString;
    edDt_Referencia.Text     := FieldByName('Dt_Referencia').AsString;
    edHoras_Trabalhadas.Text := FieldByName('Horas_Trabalhadas').AsString;
    edAndamento.Text         := FieldByName('Andamento').AsString;
    edNo_Departamento.Text   := FieldByName('No_Departamento').AsString;
    edNo_Projeto.Text        := FieldByName('No_Projeto').AsString;
    edNo_Atividade.Text      := FieldByName('No_Atividade').AsString;
    edNo_Tarefa.Text         := FieldByName('No_Tarefa').AsString;
    edNo_Recurso.Text        := FieldByName('No_Recurso').AsString;

    ShowModal;
    Open;
  end;
end;

procedure TfDossie.btSaiClick(Sender: TObject);
begin
  fdmActivity.qryDossie.Close;
  Close;
end;

end.
