unit uProcesso;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, DBCtrls, Grids, DBGrids, StdCtrls, Buttons;

type
  TfProcesso = class(TForm)
    DBGrid: TDBGrid;
    DBNavigator: TDBNavigator;
    Label1: TLabel;
    Label2: TLabel;
    btIncluir: TButton;
    btAlterar: TButton;
    btExcluir: TButton;
    btSai: TBitBtn;
    procedure btIncluirClick(Sender: TObject);
    procedure btAlterarClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure btSaiClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  fProcesso: TfProcesso;

implementation

uses udmActivity, u2Processo;

{$R *.dfm}

procedure TfProcesso.FormShow(Sender: TObject);
begin
  DBGrid.DataSource := fdmActivity.dsProcesso;
  DBNavigator.DataSource := fdmActivity.dsProcesso;
  fdmActivity.qryProcesso.Open;
end;

procedure TfProcesso.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
{ Libera o formulrio }
  Action := caFree;
  fProcesso := nil;
end;

procedure TfProcesso.btIncluirClick(Sender: TObject);
begin
  if f2Processo = nil then
    f2Processo := Tf2Processo.Create(Application);

  with f2Processo, fdmActivity.qryProcesso do
  begin
    lbOperacao.Caption := 'Incluir Processo';

    edNu_Departamento.Color    := clWindow;
    edNu_Departamento.ReadOnly := False;
    edNu_Departamento.TabStop  := True;
    edNu_Projeto.Color         := clWindow;
    edNu_Projeto.ReadOnly      := False;
    edNu_Projeto.TabStop       := True;
    edNu_Atividade.Color       := clWindow;
    edNu_Atividade.ReadOnly    := False;
    edNu_Atividade.TabStop     := True;
    edNu_Tarefa.Color          := clWindow;
    edNu_Tarefa.ReadOnly       := False;
    edNu_Tarefa.TabStop        := True;
    edNu_Recurso.Color         := clWindow;
    edNu_Recurso.ReadOnly      := False;
    edNu_Recurso.TabStop       := True;

    edNu_Departamento.Text := '';
    edNu_Projeto.Text      := '';
    edNu_Atividade.Text    := '';
    edNu_Tarefa.Text       := '';
    edNu_Recurso.Text      := '';
    edDt_Inicio.Text       := 'null';
    edDt_Encerramento.Text := 'null';
    edDetalhe.Text         := '';
    edNo_Departamento.Text := '';
    edNo_Projeto.Text      := '';
    edNo_Atividade.Text    := '';
    edNo_Tarefa.Text       := '';
    edNo_Recurso.Text      := '';

    ShowModal;
    Open;
  end;
end;

procedure TfProcesso.btAlterarClick(Sender: TObject);
begin
  if f2Processo = nil then
    f2Processo := Tf2Processo.Create(Application);

  with f2Processo, fdmActivity.qryProcesso do
  begin
    if (Sender = btAlterar) then
      lbOperacao.Caption := 'Alterar Processo'
    else
    if (Sender = btExcluir) then
      lbOperacao.Caption := 'Excluir Processo';

    edNu_Departamento.Color    := clSilver;
    edNu_Departamento.ReadOnly := True;
    edNu_Departamento.TabStop  := False;
    edNu_Projeto.Color         := clSilver;
    edNu_Projeto.ReadOnly      := True;
    edNu_Projeto.TabStop       := False;
    edNu_Atividade.Color       := clSilver;
    edNu_Atividade.ReadOnly    := True;
    edNu_Atividade.TabStop     := False;
    edNu_Tarefa.Color          := clSilver;
    edNu_Tarefa.ReadOnly       := True;
    edNu_Tarefa.TabStop        := False;
    edNu_Recurso.Color         := clSilver;
    edNu_Recurso.ReadOnly      := True;
    edNu_Recurso.TabStop       := False;

    edNu_Departamento.Text := FieldByName('Nu_Departamento').AsString;
    edNu_Projeto.Text      := FieldByName('Nu_Projeto').AsString;
    edNu_Atividade.Text    := FieldByName('Nu_Atividade').AsString;
    edNu_Tarefa.Text       := FieldByName('Nu_Tarefa').AsString;
    edNu_Recurso.Text      := FieldByName('Nu_Recurso').AsString;
    edDt_Inicio.Text       := FieldByName('Dt_Inicio').AsString;
    edDt_Encerramento.Text := FieldByName('Dt_Encerramento').AsString;
    edDetalhe.Text         := FieldByName('Detalhe').AsString;
    edNo_Departamento.Text := FieldByName('No_Departamento').AsString;
    edNo_Projeto.Text      := FieldByName('No_Projeto').AsString;
    edNo_Atividade.Text    := FieldByName('No_Atividade').AsString;
    edNo_Tarefa.Text       := FieldByName('No_Tarefa').AsString;
    edNo_Recurso.Text      := FieldByName('No_Recurso').AsString;

    ShowModal;
    Open;
  end;
end;

procedure TfProcesso.btSaiClick(Sender: TObject);
begin
  fdmActivity.qryProcesso.Close;
  Close;
end;

end.
