unit uProjeto;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, DBCtrls, Grids, DBGrids, StdCtrls, Buttons;

type
  TfProjeto = class(TForm)
    DBGrid: TDBGrid;
    DBNavigator: TDBNavigator;
    Label1: TLabel;
    Label2: TLabel;
    btIncluir: TButton;
    btAlterar: TButton;
    btExcluir: TButton;
    btSai: TBitBtn;
    procedure btIncluirClick(Sender: TObject);
    procedure btAlterarClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure btSaiClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  fProjeto: TfProjeto;

implementation

uses udmActivity, u2Projeto;

{$R *.dfm}

procedure TfProjeto.FormShow(Sender: TObject);
begin
  DBGrid.DataSource := fdmActivity.dsProjeto;
  DBNavigator.DataSource := fdmActivity.dsProjeto;
  fdmActivity.qryProjeto.Open;
end;

procedure TfProjeto.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
{ Libera o formulrio }
  Action := caFree;
  fProjeto := nil;
end;

procedure TfProjeto.btIncluirClick(Sender: TObject);
begin
  if f2Projeto = nil then
    f2Projeto := Tf2Projeto.Create(Application);

  with f2Projeto, fdmActivity.qryProjeto do
  begin
    lbOperacao.Caption := 'Incluir Projeto';

    edNu_Departamento.Color    := clWindow;
    edNu_Departamento.ReadOnly := False;
    edNu_Departamento.TabStop  := True;
    edNu_Projeto.Color         := clSilver;
    edNu_Projeto.ReadOnly      := True;
    edNu_Projeto.TabStop       := False;

    edNu_Departamento.Text := '';
    edNu_Projeto.Text      := 'null';
    edSg_Projeto.Text      := '';
    edNo_Projeto.Text      := '';
    edDt_Criacao.Text      := 'null';
    edDt_Inicio.Text       := 'null';
    edDt_Encerramento.Text := 'null';
    edSituacao.Text        := '';
    edNu_Recurso.Text      := '';
    edNo_Departamento.Text := '';
    edNo_Recurso.Text      := '';

    ShowModal;
    Open;
  end;
end;

procedure TfProjeto.btAlterarClick(Sender: TObject);
begin
  if f2Projeto = nil then
    f2Projeto := Tf2Projeto.Create(Application);

  with f2Projeto, fdmActivity.qryProjeto do
  begin
    if (Sender = btAlterar) then
      lbOperacao.Caption := 'Alterar Projeto'
    else
    if (Sender = btExcluir) then
      lbOperacao.Caption   := 'Excluir Projeto';

    edNu_Departamento.Color    := clSilver;
    edNu_Departamento.ReadOnly := True;
    edNu_Departamento.TabStop  := False;
    edNu_Projeto.Color         := clSilver;
    edNu_Projeto.ReadOnly      := True;
    edNu_Projeto.TabStop       := False;

    edNu_Departamento.Text := FieldByName('Nu_Departamento').AsString;
    edNu_Projeto.Text      := FieldByName('Nu_Projeto').AsString;
    edSg_Projeto.Text      := FieldByName('Sg_Projeto').AsString;
    edNo_Projeto.Text      := FieldByName('No_Projeto').AsString;
    edDt_Criacao.Text      := FieldByName('Dt_Criacao').AsString;
    edDt_Inicio.Text       := FieldByName('Dt_Inicio').AsString;
    edDt_Encerramento.Text := FieldByName('Dt_Encerramento').AsString;
    edSituacao.Text        := FieldByName('Situacao').AsString;
    edNu_Recurso.Text      := FieldByName('Nu_Recurso').AsString;
    edNo_Departamento.Text := FieldByName('No_Departamento').AsString;
    edNo_Recurso.Text      := FieldByName('No_Recurso').AsString;

    ShowModal;
    Open;
  end;
end;

procedure TfProjeto.btSaiClick(Sender: TObject);
begin
  fdmActivity.qryProjeto.Close;
  Close;
end;

end.
