unit uTarefa;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, DBCtrls, Grids, DBGrids, StdCtrls, Buttons;

type
  TfTarefa = class(TForm)
    DBGrid: TDBGrid;
    DBNavigator: TDBNavigator;
    Label1: TLabel;
    Label2: TLabel;
    btIncluir: TButton;
    btAlterar: TButton;
    btExcluir: TButton;
    btSai: TBitBtn;
    procedure btIncluirClick(Sender: TObject);
    procedure btAlterarClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure btSaiClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  fTarefa: TfTarefa;

implementation

uses udmActivity, u2Tarefa;

{$R *.dfm}

procedure TfTarefa.FormShow(Sender: TObject);
begin
  DBGrid.DataSource := fdmActivity.dsTarefa;
  DBNavigator.DataSource := fdmActivity.dsTarefa;
  fdmActivity.qryTarefa.Open;
end;

procedure TfTarefa.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
{ Libera o formulrio }
  Action := caFree;
  fTarefa := nil;
end;

procedure TfTarefa.btIncluirClick(Sender: TObject);
begin
  if f2Tarefa = nil then
    f2Tarefa := Tf2Tarefa.Create(Application);

  with f2Tarefa, fdmActivity.qryTarefa do
  begin
    lbOperacao.Caption := 'Incluir Tarefa';

    edNu_Departamento.Color    := clWindow;
    edNu_Departamento.ReadOnly := False;
    edNu_Departamento.TabStop  := True;
    edNu_Projeto.Color         := clWindow;
    edNu_Projeto.ReadOnly      := False;
    edNu_Projeto.TabStop       := True;
    edNu_Atividade.Color       := clWindow;
    edNu_Atividade.ReadOnly    := False;
    edNu_Atividade.TabStop     := True;
    edNu_Tarefa.Color          := clSilver;
    edNu_Tarefa.ReadOnly       := True;
    edNu_Tarefa.TabStop        := False;

    edNu_Departamento.Text := '';
    edNu_Projeto.Text      := '';
    edNu_Atividade.Text    := '';
    edNu_Tarefa.Text       := 'null';
    edNo_Tarefa.Text       := '';
    edDt_Inicio.Text       := 'null';
    edDt_Encerramento.Text := 'null';
    edNo_Departamento.Text := '';
    edNo_Projeto.Text      := '';
    edNo_Atividade.Text    := '';

    ShowModal;
    Open;
  end;
end;

procedure TfTarefa.btAlterarClick(Sender: TObject);
begin
  if f2Tarefa = nil then
    f2Tarefa := Tf2Tarefa.Create(Application);

  with f2Tarefa, fdmActivity.qryTarefa do
  begin
    if (Sender = btAlterar) then
      lbOperacao.Caption := 'Alterar Tarefa'
    else
    if (Sender = btExcluir) then
      lbOperacao.Caption := 'Excluir Tarefa';

    edNu_Departamento.Color    := clSilver;
    edNu_Departamento.ReadOnly := True;
    edNu_Departamento.TabStop  := False;
    edNu_Projeto.Color         := clSilver;
    edNu_Projeto.ReadOnly      := True;
    edNu_Projeto.TabStop       := False;
    edNu_Atividade.Color       := clSilver;
    edNu_Atividade.ReadOnly    := True;
    edNu_Atividade.TabStop     := False;
    edNu_Tarefa.Color          := clSilver;
    edNu_Tarefa.ReadOnly       := True;
    edNu_Tarefa.TabStop        := False;

    edNu_Departamento.Text := FieldByName('Nu_Departamento').AsString;
    edNu_Projeto.Text      := FieldByName('Nu_Projeto').AsString;
    edNu_Atividade.Text    := FieldByName('Nu_Atividade').AsString;
    edNu_Tarefa.Text       := FieldByName('Nu_Tarefa').AsString;
    edNo_Tarefa.Text       := FieldByName('No_Tarefa').AsString;
    edDt_Inicio.Text       := FieldByName('Dt_Inicio').AsString;
    edDt_Encerramento.Text := FieldByName('Dt_Encerramento').AsString;
    edNo_Departamento.Text := FieldByName('No_Departamento').AsString;
    edNo_Projeto.Text      := FieldByName('No_Projeto').AsString;
    edNo_Atividade.Text    := FieldByName('No_Atividade').AsString;

    ShowModal;
    Open;
  end;
end;

procedure TfTarefa.btSaiClick(Sender: TObject);
begin
  fdmActivity.qryTarefa.Close;
  Close;
end;

end.
